<?php
/*------------------------------------------------------------------------
 # Sot k2 Scroller  - Version 1.0
 # Copyright (C) 2010-2011 Sky Of Tech. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: Sky Of Tech
 # Websites: http://skyoftech.com
 -------------------------------------------------------------------------*/
 
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');
require_once (JPATH_SITE .DS.'modules'.DS.$module->module.DS.'libs'.DS.'SimpleImage'.DS.'SimpleImage.php');

if (! class_exists("Sotk2") ) {
	class Sotk2 {	
		var $thumb_width = '40';
		var $thumb_height = '40';
		var $web_url = '';	
		var $cropresizeimage = 0;
		var $max_title = 0;
		var $max_description = 0;
		var $max_short_desc = 0;
		var $resize_folder = '';
		var $crop_folder = '';
		var $url_to_resize = '';
		var $url_to_crop = '';
		
		function getItems(&$params, $format = 'html') {
	
			jimport('joomla.filesystem.file');
			$limit = $params->get('itemCount', 5);
			$cid = $params->get('category_id', NULL);
			$ordering = $params->get('itemsOrdering','');
			$componentParams = &JComponentHelper::getParams('com_k2');
			$limitstart = JRequest::getInt('limitstart');
	
			$user = &JFactory::getUser();
			$aid = $user->get('aid');
			$db = &JFactory::getDBO();
	
			$jnow = &JFactory::getDate();
			$now = $jnow->toMySQL();
			$nullDate = $db->getNullDate();
	
			if($params->get('source')=='specific'){
	
				$value = $params->get('items');
				$current = array();
				if(is_string($value) && !empty($value))
				$current[]=$value;
				if(is_array($value))
				$current=$value;
	
				$items = array();
	
				foreach($current as $id){
	
					$query = "SELECT i.id, i.title, i.alias, i.catid, i.introtext, i.fulltext, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams";
					$query .= " FROM #__k2_items as i LEFT JOIN #__k2_categories c ON c.id = i.catid";
					$query .= " WHERE i.published = 1 AND i.access <= {$aid} AND i.trash = 0 AND c.published = 1 AND c.access <= {$aid} AND c.trash = 0";
					$query .= " AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." )";
					$query .= " AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )";
					$query .= " AND i.id={$id}";
					$db->setQuery($query);
					$item = $db->loadObject();
					if($item)
					$items[]=$item;
	
				}
			}
	
			else {
				$query = "SELECT i.id, i.title, i.alias, i.catid, i.introtext, i.fulltext, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias";
	
				if ($ordering == 'best')
				$query .= ", (r.rating_sum/r.rating_count) AS rating";
	
				if ($ordering == 'comments')
				$query .= ", COUNT(comments.id) AS numOfComments";
	
				$query .= " FROM #__k2_items as i LEFT JOIN #__k2_categories c ON c.id = i.catid";
	
				if ($ordering == 'best')
				$query .= " LEFT JOIN #__k2_rating r ON r.itemID = i.id";
	
				if ($ordering == 'comments')
				$query .= " LEFT JOIN #__k2_comments comments ON comments.itemID = i.id";
	
				$query .= " WHERE i.published = 1 AND i.access <= {$aid} AND i.trash = 0 AND c.published = 1 AND c.access <= {$aid} AND c.trash = 0";
	
				$query .= " AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." )";
				$query .= " AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )";
	
	
				if ($params->get('catfilter')) {
					if (!is_null($cid)) {
						if (is_array($cid)) {
							if ($params->get('getChildren')) {
								require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
								$allChildren = array();
								foreach ($cid as $id) {
									$categories = K2ModelItemlist::getCategoryChilds($id, true);
									$categories[] = $id;
									$categories = @array_unique($categories);
									$allChildren = @array_merge($allChildren, $categories);
								}
	
								$allChildren = @array_unique($allChildren);
								JArrayHelper::toInteger($allChildren);
								$sql = @implode(',', $allChildren);
								$query .= " AND i.catid IN ({$sql})";
	
							} else {
								JArrayHelper::toInteger($cid);
								$query .= " AND i.catid IN(".implode(',', $cid).")";
							}
	
						} else {
							if ($params->get('getChildren')) {
								require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
								$categories = K2ModelItemlist::getCategoryChilds($cid, true);
								$categories[] = $cid;
								$categories = @array_unique($categories);
								JArrayHelper::toInteger($categories);
								$sql = @implode(',', $categories);
								$query .= " AND i.catid IN ({$sql})";
							} else {
								$query .= " AND i.catid=".(int)$cid;
							}
	
						}
					}
				}
	
				if ($params->get('FeaturedItems') == '0')
				$query .= " AND i.featured != 1";
	
				if ($params->get('FeaturedItems') == '2')
				$query .= " AND i.featured = 1";
	
				if ($params->get('videosOnly'))
				$query .= " AND (i.video IS NOT NULL AND i.video!='')";
	
				if ($ordering == 'comments')
				$query .= " AND comments.published = 1";
	
	
				switch ($ordering) {
	
					case 'date':
						$orderby = 'i.created ASC';
						break;
	
					case 'rdate':
						$orderby = 'i.created DESC';
						break;
	
					case 'alpha':
						$orderby = 'i.title';
						break;
	
					case 'ralpha':
						$orderby = 'i.title DESC';
						break;
	
					case 'order':
						if ($params->get('FeaturedItems') == '2')
						$orderby = 'i.featured_ordering';
						else
						$orderby = 'i.ordering';
						break;
	
					case 'rorder':
						if ($params->get('FeaturedItems') == '2')
						$orderby = 'i.featured_ordering DESC';
						else
						$orderby = 'i.ordering DESC';
						break;
	
					case 'hits':
						if ($params->get('popularityRange')){
							$datenow = &JFactory::getDate();
							$date = $datenow->toMySQL();
							$query.=" AND i.created > DATE_SUB('{$date}',INTERVAL ".$params->get('popularityRange')." DAY) ";
						}
						$orderby = 'i.hits DESC';
						break;
	
					case 'rand':
						$orderby = 'RAND()';
						break;
	
					case 'best':
						$orderby = 'rating DESC';
						break;
	
					case 'comments':
						if ($params->get('popularityRange')){
							$datenow = &JFactory::getDate();
							$date = $datenow->toMySQL();
							$query.=" AND i.created > DATE_SUB('{$date}',INTERVAL ".$params->get('popularityRange')." DAY) ";
						}
						$query.=" GROUP BY i.id ";
						$orderby = 'numOfComments DESC';
						break;
						
					case 'modified':
						$orderby = 'i.modified DESC';
						break;
	
					default:
						$orderby = 'i.id DESC';
						break;
				}
	
	
				$query .= " ORDER BY ".$orderby;
				$db->setQuery($query, 0, $limit);
				$items = $db->loadObjectList();
			}
			
			if (count($items)) {
				return $this->update($params, $items);
			} else return array();
	
			
	
		}		
		
		function update($params, $items ) {	
			$tmp = array();
			
			foreach ($items as $key => $item) {
				$item_final = array();
				$item->title = JFilterOutput::ampReplace($item->title);
				//Images
				
				if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XS.jpg'))
				$item->imageXSmall = 'media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg';

				if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_S.jpg'))
				$item->imageSmall = 'media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg';

				if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_M.jpg'))
				$item->imageMedium = 'media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg';

				if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_L.jpg'))
				$item->imageLarge = 'media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg';

				if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XL.jpg'))
				$item->imageXLarge = 'media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';

				if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_Generic.jpg'))
				$item->imageGeneric = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg';

				$image = 'image'.$params->get('itemImgSize','Small');
				if (isset($item->$image)){
					$item->image = $item->$image;
				}
				else{
					preg_match ( "#<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>#iU" , $item->introtext.$item->fulltext, $matches); 
					$images = (count($matches)) ? $matches : array();
					if (count($images)){				
						$item->image = $images[1];
					} else {				
						$item->image = '';	
					}
				}	
				$item->introtext = $this->removeImage($item->introtext);
				//Read more link
				$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
				$item_final['link'] = $item->link;
				$item_final['fulltext'] = $item->fulltext;
				$item_final['title'] = $item->title;
				if (!isset($item_final['sub_title'])) {
					$item_final['sub_title'] = $this->truncate($item->title, $this->max_title, '...', true, true);
				}
				
				if (!isset($item_final['sub_content'])) {
					$content = $this->truncate($item->introtext, $this->max_description, '...', true, true);
					$item_final['sub_content'] = $content;
				}
				
				if (!isset($item_final['sub_short_content'])) {
					$content = $this->substrwords($item->introtext, $this->max_short_desc, '...');
					$item_final['sub_short_content'] = $content;
				}
				
				if (!isset($item_final['thumb']) && $item->image != '') {
					$item_final['thumb'] = $this->processImage($item->image, $this->thumb_width, $this->thumb_height);
				} else {
					$item_final['thumb'] = '';
				}		
				
				if (!isset($item_final['small_thumb']) && $item->image != '') {
					$item_final['small_thumb'] = $this->processImage($item->image, $this->small_thumb_width, $this->small_thumb_height);
				} else {
					$item_final['small_thumb'] = '';
				}
				//var_dump($item_final);die;
				if ($item_final['thumb'] != '') {			
					$tmp[] = $item_final;
				}
			}
			
			return $tmp;				
		}
		
		function removeImage($str) {
			$regex1 = "/\<img[^\>]*>/";
			$str = preg_replace ( $regex1, '', $str );
			$regex1 = "/<div class=\"mosimage\".*<\/div>/";
			$str = preg_replace ( $regex1, '', $str );
			$str = trim ( $str );
			
			return $str;
		}
		function processImage($img, $width, $height) {
					
			if ($this->cropresizeimage == 0) {
				return $this->resizeImage($img, $width, $height);
			} else {
				return $this->cropImage($img, $width, $height);
			}
		}
			
		function resizeImage($imagePath, $width, $height) {
			global $module;
					
			$folderPath = $this->resize_folder;
			 
			 if(!JFolder::exists($folderPath)){
					JFolder::create($folderPath);	 
			 }
			  
			 $nameImg = str_replace('/','',strrchr($imagePath,"/"));		
			 $ext = substr($nameImg, strrpos($nameImg, '.'));
			 $file_name = substr($nameImg, 0,  strrpos($nameImg, '.'));
			 $nameImg = str_replace(" ","",$file_name . "_" . $width . "_" . $height .  $ext);
					 
			 if(!JFile::exists($folderPath.DS.$nameImg)){
				 $image = new SimpleImage();
				 $image->load($imagePath);
				 $image->resize($width,$height);
				 $image->save($folderPath.DS.$nameImg);
			 }else{
					 list($info_width, $info_height) = @getimagesize($folderPath.DS.$nameImg);
					 if($width!=$info_width||$height!=$info_height){
						 $image = new SimpleImage();
						 $image->load($imagePath);
						 $image->resize($width,$height);
						 $image->save($folderPath.DS.$nameImg);
					 }
			 }
			 return $this->url_to_resize . $nameImg;
		}
		
		function cropImage($imagePath, $width, $height) {
			global $module;
			
			$folderPath = $this->crop_folder;
	
			if(!JFolder::exists($folderPath)){
					JFolder::create($folderPath);	 
			}
			$nameImg = str_replace('/','',strrchr($imagePath,"/")); 
			$ext = substr($nameImg, strrpos($nameImg, '.'));
			$file_name = substr($nameImg, 0,  strrpos($nameImg, '.'));
			$nameImg = str_replace(" ","",$file_name . "_" . $width . "_" . $height .  $ext);	 
			 
			 if(!JFile::exists($folderPath.DS.$nameImg)){
				 $image = new SimpleImage();
				 $image->load($imagePath);
				 $image->crop($width,$height);
				 $image->save($folderPath.DS.$nameImg);
			 }else{
					 list($info_width, $info_height) = @getimagesize($folderPath.DS.$nameImg);
					 if($width!=$info_width||$height!=$info_height){
						 $image = new SimpleImage();
						 $image->load($imagePath);
						 $image->crop($width,$height);
						 $image->save($folderPath.DS.$nameImg);
					 }
			 }
			 
			 return $this->url_to_crop . $nameImg;
		}
		
		/**
		 * Truncates text.
		 *
		 * Cuts a string to the length of $length and replaces the last characters
		 * with the ending if the text is longer than length.
		 *
		 * @param string  $text String to truncate.
		 * @param integer $length Length of returned string, including ellipsis.
		 * @param string  $ending Ending to be appended to the trimmed string.
		 * @param boolean $exact If false, $text will not be cut mid-word
		 * @param boolean $considerHtml If true, HTML tags would be handled correctly
		 * @return string Trimmed string.
		 */
		function truncate($text, $length = 100, $ending = '...', $exact = true, $considerHtml = false) {
			if ($considerHtml) {
				// if the plain text is shorter than the maximum length, return the whole text
				if (strlen(preg_replace('/<.*?>/', '', $text)) <= $length) {
					return $text;
				}
				// splits all html-tags to scanable lines
				preg_match_all('/(<.+?>)?([^<>]*)/s', $text, $lines, PREG_SET_ORDER);
				$total_length = strlen($ending);
				$open_tags = array();
				$truncate = '';
				foreach ($lines as $line_matchings) {
					// if there is any html-tag in this line, handle it and add it (uncounted) to the output
					if (!empty($line_matchings[1])) {
						// if it's an "empty element" with or without xhtml-conform closing slash (f.e. <br/>)
						if (preg_match('/^<(\s*.+?\/\s*|\s*(img|br|input|hr|area|base|basefont|col|frame|isindex|link|meta|param)(\s.+?)?)>$/is', $line_matchings[1])) {
							// do nothing
						// if tag is a closing tag (f.e. </b>)
						} else if (preg_match('/^<\s*\/([^\s]+?)\s*>$/s', $line_matchings[1], $tag_matchings)) {
							// delete tag from $open_tags list
							$pos = array_search($tag_matchings[1], $open_tags);
							if ($pos !== false) {
								unset($open_tags[$pos]);
							}
						// if tag is an opening tag (f.e. <b>)
						} else if (preg_match('/^<\s*([^\s>!]+).*?>$/s', $line_matchings[1], $tag_matchings)) {
							// add tag to the beginning of $open_tags list
							array_unshift($open_tags, strtolower($tag_matchings[1]));
						}
						// add html-tag to $truncate'd text
						$truncate .= $line_matchings[1];
					}
					// calculate the length of the plain text part of the line; handle entities as one character
					$content_length = strlen(preg_replace('/&[0-9a-z]{2,8};|&#[0-9]{1,7};|[0-9a-f]{1,6};/i', ' ', $line_matchings[2]));
					if ($total_length+$content_length> $length) {
						// the number of characters which are left
						$left = $length - $total_length;
						$entities_length = 0;
						// search for html entities
						if (preg_match_all('/&[0-9a-z]{2,8};|&#[0-9]{1,7};|[0-9a-f]{1,6};/i', $line_matchings[2], $entities, PREG_OFFSET_CAPTURE)) {
							// calculate the real length of all entities in the legal range
							foreach ($entities[0] as $entity) {
								if ($entity[1]+1-$entities_length <= $left) {
									$left--;
									$entities_length += strlen($entity[0]);
								} else {
									// no more characters left
									break;
								}
							}
						}
						$truncate .= substr($line_matchings[2], 0, $left+$entities_length);
						// maximum lenght is reached, so get off the loop
						break;
					} else {
						$truncate .= $line_matchings[2];
						$total_length += $content_length;
					}
					// if the maximum length is reached, get off the loop
					if($total_length>= $length) {
						break;
					}
				}
			} else {
				if (strlen($text) <= $length) {
					return $text;
				} else {
					$truncate = substr($text, 0, $length - strlen($ending));
				}
			}
			// if the words shouldn't be cut in the middle...
			if (!$exact) {
				// ...search the last occurance of a space...
				$spacepos = strrpos($truncate, ' ');
				if (isset($spacepos)) {
					// ...and cut the text in this position
					$truncate = substr($truncate, 0, $spacepos);
				}
			}
			// add the defined ending to the text
			$truncate .= $ending;
			if($considerHtml) {
				// close all unclosed html-tags
				foreach ($open_tags as $tag) {
					$truncate .= '</' . $tag . '>';
				}
			}
			return $truncate;
		}
	
		function substrwords($text,$maxchar,$end='...'){
			$text = strip_tags($text);
			if(strlen($text)>$maxchar){
				$words=explode(" ",$text);
				$output = '';
				$i=0;
				while(1){
				$length = (strlen($output)+strlen($words[$i]));
					if($length>$maxchar){
						break;
					}else{
						$output = $output." ".$words[$i];
						++$i;
					};
				};
			}else{
				$output = $text;
			}
			return $output.$end;
		}
		
	}
}


?>
